/* MainWindow.c generated by valac 0.55.1, the Vala compiler
 * generated from MainWindow.vala, do not modify */

/*
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: 2017-2021 Daniel Foré (https://github.com/danrabbit)
 */

#include <handy.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define MAIN_WINDOW_RESULTS_CSS "\n" \
"        @define-color colorForeground %s;\n" \
"        @define-color colorBackground %s;\n" \
"\n" \
"        .results {\n" \
"            transition: all 250ms ease-in-out;\n" \
"        }\n" \
"    "
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MAIN_WINDOW (main_window_get_type ())
#define MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MAIN_WINDOW, MainWindow))
#define MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MAIN_WINDOW, MainWindowClass))
#define IS_MAIN_WINDOW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MAIN_WINDOW))
#define IS_MAIN_WINDOW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MAIN_WINDOW))
#define MAIN_WINDOW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MAIN_WINDOW, MainWindowClass))

typedef struct _MainWindow MainWindow;
typedef struct _MainWindowClass MainWindowClass;
typedef struct _MainWindowPrivate MainWindowPrivate;

#define TYPE_GRADE_LABEL (grade_label_get_type ())
#define GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GRADE_LABEL, GradeLabel))
#define GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GRADE_LABEL, GradeLabelClass))
#define IS_GRADE_LABEL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GRADE_LABEL))
#define IS_GRADE_LABEL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GRADE_LABEL))
#define GRADE_LABEL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GRADE_LABEL, GradeLabelClass))

typedef struct _GradeLabel GradeLabel;
typedef struct _GradeLabelClass GradeLabelClass;
enum  {
	MAIN_WINDOW_0_PROPERTY,
	MAIN_WINDOW_NUM_PROPERTIES
};
static GParamSpec* main_window_properties[MAIN_WINDOW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block2Data Block2Data;

struct _MainWindow {
	HdyWindow parent_instance;
	MainWindowPrivate * priv;
};

struct _MainWindowClass {
	HdyWindowClass parent_class;
};

struct _MainWindowPrivate {
	GdkRGBA gdk_color;
	GtkEntry* bg_entry;
	GtkEntry* fg_entry;
	GtkLabel* results_label;
	GradeLabel* a_level;
	GradeLabel* aa_level;
	GradeLabel* aaa_level;
	gchar* prev_foreground_entry;
	gchar* prev_background_entry;
};

struct _Block2Data {
	int _ref_count_;
	MainWindow* self;
	GtkColorSelection* widget;
	GtkEntry* entry;
};

static gint MainWindow_private_offset;
static gpointer main_window_parent_class = NULL;
VALA_EXTERN GSettings* harvey_settings;

VALA_EXTERN GType main_window_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MainWindow, g_object_unref)
VALA_EXTERN GType grade_label_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GradeLabel, g_object_unref)
VALA_EXTERN MainWindow* main_window_new (GtkApplication* application);
VALA_EXTERN MainWindow* main_window_construct (GType object_type,
                                   GtkApplication* application);
static void main_window_on_entry_icon_press (MainWindow* self,
                                      GtkEntry* entry);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void __lambda4_ (Block2Data* _data2_);
static void ___lambda4__gtk_color_selection_color_changed (GtkColorSelection* _sender,
                                                    gpointer self);
static void main_window_on_entry_changed (MainWindow* self);
static void main_window_style_results_pane (MainWindow* self,
                                     const gchar* fg_color,
                                     const gchar* bg_color);
static gdouble main_window_get_luminance (MainWindow* self,
                                   GdkRGBA* color);
VALA_EXTERN void grade_label_set_pass (GradeLabel* self,
                           gboolean value);
static gdouble main_window_sanitize_color (MainWindow* self,
                                    gdouble color);
static gboolean main_window_real_configure_event (GtkWidget* base,
                                           GdkEventConfigure* event);
static GObject * main_window_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
VALA_EXTERN GradeLabel* grade_label_new (const gchar* level);
VALA_EXTERN GradeLabel* grade_label_construct (GType object_type,
                                   const gchar* level);
static void _main_window___lambda5_ (MainWindow* self,
                              GtkEntryIconPosition pos,
                              GdkEvent* event);
static void __main_window___lambda5__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEvent* event,
                                                    gpointer self);
static void _main_window___lambda6_ (MainWindow* self);
static void __main_window___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void _main_window___lambda7_ (MainWindow* self,
                              GtkEntryIconPosition pos,
                              GdkEvent* event);
static void __main_window___lambda7__gtk_entry_icon_press (GtkEntry* _sender,
                                                    GtkEntryIconPosition icon_pos,
                                                    GdkEvent* event,
                                                    gpointer self);
static void _main_window___lambda8_ (MainWindow* self);
static void __main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                                    gpointer self);
static void main_window_finalize (GObject * obj);
static GType main_window_get_type_once (void);

static inline gpointer
main_window_get_instance_private (MainWindow* self)
{
	return G_STRUCT_MEMBER_P (self, MainWindow_private_offset);
}

MainWindow*
main_window_construct (GType object_type,
                       GtkApplication* application)
{
	MainWindow * self = NULL;
	g_return_val_if_fail (application != NULL, NULL);
	self = (MainWindow*) g_object_new (object_type, "application", application, "height-request", 500, "icon-name", "com.github.danrabbit.harvey", "resizable", FALSE, "title", _ ("Harvey"), "width-request", 700, NULL);
	return self;
}

MainWindow*
main_window_new (GtkApplication* application)
{
	return main_window_construct (TYPE_MAIN_WINDOW, application);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		MainWindow* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->entry);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static void
__lambda4_ (Block2Data* _data2_)
{
	MainWindow* self;
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	GtkColorSelection* _tmp12_;
	GdkRGBA _tmp13_ = {0};
	GdkRGBA _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	self = _data2_->self;
	_tmp1_ = self->priv->fg_entry;
	if (_data2_->entry == _tmp1_) {
		const gchar* _tmp2_;
		_tmp2_ = self->priv->prev_foreground_entry;
		_tmp0_ = _tmp2_ == NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp3_ = gtk_entry_get_text (_data2_->entry);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strdup (_tmp4_);
		_g_free0 (self->priv->prev_foreground_entry);
		self->priv->prev_foreground_entry = _tmp5_;
	} else {
		gboolean _tmp6_ = FALSE;
		GtkEntry* _tmp7_;
		_tmp7_ = self->priv->bg_entry;
		if (_data2_->entry == _tmp7_) {
			const gchar* _tmp8_;
			_tmp8_ = self->priv->prev_background_entry;
			_tmp6_ = _tmp8_ == NULL;
		} else {
			_tmp6_ = FALSE;
		}
		if (_tmp6_) {
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
			_tmp9_ = gtk_entry_get_text (_data2_->entry);
			_tmp10_ = _tmp9_;
			_tmp11_ = g_strdup (_tmp10_);
			_g_free0 (self->priv->prev_background_entry);
			self->priv->prev_background_entry = _tmp11_;
		}
	}
	_tmp12_ = _data2_->widget;
	gtk_color_selection_get_current_rgba (_tmp12_, &_tmp13_);
	_tmp14_ = _tmp13_;
	_tmp15_ = gdk_rgba_to_string (&_tmp14_);
	_tmp16_ = _tmp15_;
	gtk_entry_set_text (_data2_->entry, _tmp16_);
	_g_free0 (_tmp16_);
}

static void
___lambda4__gtk_color_selection_color_changed (GtkColorSelection* _sender,
                                               gpointer self)
{
	__lambda4_ (self);
}

static void
main_window_on_entry_icon_press (MainWindow* self,
                                 GtkEntry* entry)
{
	Block2Data* _data2_;
	GtkEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GtkColorSelectionDialog* dialog = NULL;
	GtkColorSelectionDialog* _tmp3_;
	GtkColorSelectionDialog* _tmp4_;
	GtkColorSelectionDialog* _tmp5_;
	GtkColorSelectionDialog* _tmp6_;
	GtkColorSelection* _tmp7_;
	GtkColorSelection* _tmp8_;
	GdkRGBA _tmp9_;
	GtkColorSelection* _tmp10_;
	GtkColorSelectionDialog* _tmp11_;
	GtkColorSelectionDialog* _tmp23_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (entry != NULL);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (entry);
	_g_object_unref0 (_data2_->entry);
	_data2_->entry = _tmp0_;
	_tmp1_ = gtk_entry_get_text (_data2_->entry);
	_tmp2_ = _tmp1_;
	gdk_rgba_parse (&self->priv->gdk_color, _tmp2_);
	_tmp3_ = (GtkColorSelectionDialog*) gtk_color_selection_dialog_new ("");
	g_object_ref_sink (_tmp3_);
	dialog = _tmp3_;
	_tmp4_ = dialog;
	gtk_window_set_deletable ((GtkWindow*) _tmp4_, FALSE);
	_tmp5_ = dialog;
	gtk_window_set_transient_for ((GtkWindow*) _tmp5_, (GtkWindow*) self);
	_tmp6_ = dialog;
	_tmp7_ = gtk_color_selection_dialog_get_color_selection (_tmp6_);
	_data2_->widget = _tmp7_;
	_tmp8_ = _data2_->widget;
	_tmp9_ = self->priv->gdk_color;
	gtk_color_selection_set_current_rgba (_tmp8_, &_tmp9_);
	_tmp10_ = _data2_->widget;
	g_signal_connect_data (_tmp10_, "color-changed", (GCallback) ___lambda4__gtk_color_selection_color_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp11_ = dialog;
	if (gtk_dialog_run ((GtkDialog*) _tmp11_) == ((gint) GTK_RESPONSE_OK)) {
		GtkColorSelection* _tmp12_;
		GdkRGBA _tmp13_ = {0};
		GdkRGBA _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		_tmp12_ = _data2_->widget;
		gtk_color_selection_get_current_rgba (_tmp12_, &_tmp13_);
		_tmp14_ = _tmp13_;
		_tmp15_ = gdk_rgba_to_string (&_tmp14_);
		_tmp16_ = _tmp15_;
		gtk_entry_set_text (_data2_->entry, _tmp16_);
		_g_free0 (_tmp16_);
	} else {
		const gchar* _tmp17_;
		const gchar* _tmp20_;
		_tmp17_ = self->priv->prev_foreground_entry;
		if (_tmp17_ != NULL) {
			GtkEntry* _tmp18_;
			const gchar* _tmp19_;
			_tmp18_ = self->priv->fg_entry;
			_tmp19_ = self->priv->prev_foreground_entry;
			gtk_entry_set_text (_tmp18_, _tmp19_);
		}
		_tmp20_ = self->priv->prev_background_entry;
		if (_tmp20_ != NULL) {
			GtkEntry* _tmp21_;
			const gchar* _tmp22_;
			_tmp21_ = self->priv->bg_entry;
			_tmp22_ = self->priv->prev_background_entry;
			gtk_entry_set_text (_tmp21_, _tmp22_);
		}
	}
	_g_free0 (self->priv->prev_foreground_entry);
	self->priv->prev_foreground_entry = NULL;
	_g_free0 (self->priv->prev_background_entry);
	self->priv->prev_background_entry = NULL;
	_tmp23_ = dialog;
	g_signal_emit_by_name ((GtkDialog*) _tmp23_, "close");
	_g_object_unref0 (dialog);
	block2_data_unref (_data2_);
	_data2_ = NULL;
}

static void
main_window_on_entry_changed (MainWindow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp1_ = self->priv->fg_entry;
	_tmp2_ = gtk_entry_get_text (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ > 2) {
		GtkEntry* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp6_ = self->priv->bg_entry;
		_tmp7_ = gtk_entry_get_text (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = strlen (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp0_ = _tmp10_ > 2;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkEntry* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		GtkEntry* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
		_tmp11_ = self->priv->fg_entry;
		_tmp12_ = gtk_entry_get_text (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = self->priv->bg_entry;
		_tmp15_ = gtk_entry_get_text (_tmp14_);
		_tmp16_ = _tmp15_;
		main_window_style_results_pane (self, _tmp13_, _tmp16_);
	}
}

static void
main_window_style_results_pane (MainWindow* self,
                                const gchar* fg_color,
                                const gchar* bg_color)
{
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GSettings* _tmp9_;
	GtkEntry* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GSettings* _tmp13_;
	GtkEntry* _tmp14_;
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gdouble pango_fg_luminance = 0.0;
	GdkRGBA _tmp17_;
	gdouble pango_bg_luminance = 0.0;
	GdkRGBA _tmp18_;
	gdouble contrast_ratio = 0.0;
	GtkLabel* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (fg_color != NULL);
	g_return_if_fail (bg_color != NULL);
	_tmp0_ = gtk_css_provider_new ();
	provider = _tmp0_;
	{
		gchar* colored_css = NULL;
		gchar* _tmp1_;
		GtkCssProvider* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		GdkScreen* _tmp7_;
		GtkCssProvider* _tmp8_;
		_tmp1_ = g_strdup_printf (MAIN_WINDOW_RESULTS_CSS, fg_color, bg_color);
		colored_css = _tmp1_;
		_tmp2_ = provider;
		_tmp3_ = colored_css;
		_tmp4_ = colored_css;
		_tmp5_ = strlen (_tmp4_);
		_tmp6_ = _tmp5_;
		gtk_css_provider_load_from_data (_tmp2_, _tmp3_, (gssize) _tmp6_, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_free0 (colored_css);
			goto __catch0_g_error;
		}
		_tmp7_ = gdk_screen_get_default ();
		_tmp8_ = provider;
		gtk_style_context_add_provider_for_screen (_tmp7_, (GtkStyleProvider*) _tmp8_, (guint) GTK_STYLE_PROVIDER_PRIORITY_APPLICATION);
		_g_free0 (colored_css);
	}
	goto __finally0;
	__catch0_g_error:
	{
		g_clear_error (&_inner_error0_);
		_g_object_unref0 (provider);
		return;
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (provider);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_tmp9_ = harvey_settings;
	_tmp10_ = self->priv->fg_entry;
	_tmp11_ = gtk_entry_get_text (_tmp10_);
	_tmp12_ = _tmp11_;
	g_settings_set_string (_tmp9_, "fg-color", _tmp12_);
	_tmp13_ = harvey_settings;
	_tmp14_ = self->priv->bg_entry;
	_tmp15_ = gtk_entry_get_text (_tmp14_);
	_tmp16_ = _tmp15_;
	g_settings_set_string (_tmp13_, "bg-color", _tmp16_);
	gdk_rgba_parse (&self->priv->gdk_color, fg_color);
	_tmp17_ = self->priv->gdk_color;
	pango_fg_luminance = main_window_get_luminance (self, &_tmp17_);
	gdk_rgba_parse (&self->priv->gdk_color, bg_color);
	_tmp18_ = self->priv->gdk_color;
	pango_bg_luminance = main_window_get_luminance (self, &_tmp18_);
	if (pango_bg_luminance > pango_fg_luminance) {
		contrast_ratio = (pango_bg_luminance + 0.05) / (pango_fg_luminance + 0.05);
	} else {
		contrast_ratio = (pango_fg_luminance + 0.05) / (pango_bg_luminance + 0.05);
	}
	_tmp19_ = self->priv->results_label;
	_tmp20_ = g_strdup_printf ("%.1f:1", contrast_ratio);
	_tmp21_ = _tmp20_;
	gtk_label_set_label (_tmp19_, _tmp21_);
	_g_free0 (_tmp21_);
	if (contrast_ratio >= ((gdouble) 3)) {
		GradeLabel* _tmp22_;
		_tmp22_ = self->priv->a_level;
		grade_label_set_pass (_tmp22_, TRUE);
	} else {
		GradeLabel* _tmp23_;
		_tmp23_ = self->priv->a_level;
		grade_label_set_pass (_tmp23_, FALSE);
	}
	if (contrast_ratio >= 4.5) {
		GradeLabel* _tmp24_;
		_tmp24_ = self->priv->aa_level;
		grade_label_set_pass (_tmp24_, TRUE);
	} else {
		GradeLabel* _tmp25_;
		_tmp25_ = self->priv->aa_level;
		grade_label_set_pass (_tmp25_, FALSE);
	}
	if (contrast_ratio >= ((gdouble) 7)) {
		GradeLabel* _tmp26_;
		_tmp26_ = self->priv->aaa_level;
		grade_label_set_pass (_tmp26_, TRUE);
	} else {
		GradeLabel* _tmp27_;
		_tmp27_ = self->priv->aaa_level;
		grade_label_set_pass (_tmp27_, FALSE);
	}
	_g_object_unref0 (provider);
}

static gdouble
main_window_get_luminance (MainWindow* self,
                           GdkRGBA* color)
{
	gdouble red = 0.0;
	GdkRGBA _tmp0_;
	gdouble green = 0.0;
	GdkRGBA _tmp1_;
	gdouble blue = 0.0;
	GdkRGBA _tmp2_;
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	g_return_val_if_fail (color != NULL, 0.0);
	_tmp0_ = *color;
	red = main_window_sanitize_color (self, _tmp0_.red) * 0.2126;
	_tmp1_ = *color;
	green = main_window_sanitize_color (self, _tmp1_.green) * 0.7152;
	_tmp2_ = *color;
	blue = main_window_sanitize_color (self, _tmp2_.blue) * 0.0722;
	result = (red + green) + blue;
	return result;
}

static gdouble
main_window_sanitize_color (MainWindow* self,
                            gdouble color)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	if (color <= 0.03928) {
		color = color / 12.92;
	} else {
		color = pow ((color + 0.055) / 1.055, 2.4);
	}
	result = color;
	return result;
}

static gboolean
main_window_real_configure_event (GtkWidget* base,
                                  GdkEventConfigure* event)
{
	MainWindow * self;
	gint root_x = 0;
	gint root_y = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	GSettings* _tmp2_;
	GSettings* _tmp3_;
	gboolean result;
	self = (MainWindow*) base;
	g_return_val_if_fail (event != NULL, FALSE);
	gtk_window_get_position ((GtkWindow*) self, &_tmp0_, &_tmp1_);
	root_x = _tmp0_;
	root_y = _tmp1_;
	_tmp2_ = harvey_settings;
	g_settings_set_int (_tmp2_, "window-x", root_x);
	_tmp3_ = harvey_settings;
	g_settings_set_int (_tmp3_, "window-y", root_y);
	result = GTK_WIDGET_CLASS (main_window_parent_class)->configure_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, hdy_window_get_type (), HdyWindow), event);
	return result;
}

static void
_main_window___lambda5_ (MainWindow* self,
                         GtkEntryIconPosition pos,
                         GdkEvent* event)
{
	g_return_if_fail (event != NULL);
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
		GtkEntry* _tmp0_;
		_tmp0_ = self->priv->fg_entry;
		main_window_on_entry_icon_press (self, _tmp0_);
	}
}

static void
__main_window___lambda5__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEvent* event,
                                               gpointer self)
{
	_main_window___lambda5_ ((MainWindow*) self, icon_pos, event);
}

static void
_main_window___lambda6_ (MainWindow* self)
{
	main_window_on_entry_changed (self);
}

static void
__main_window___lambda6__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
	_main_window___lambda6_ ((MainWindow*) self);
}

static void
_main_window___lambda7_ (MainWindow* self,
                         GtkEntryIconPosition pos,
                         GdkEvent* event)
{
	g_return_if_fail (event != NULL);
	if (pos == GTK_ENTRY_ICON_SECONDARY) {
		GtkEntry* _tmp0_;
		_tmp0_ = self->priv->bg_entry;
		main_window_on_entry_icon_press (self, _tmp0_);
	}
}

static void
__main_window___lambda7__gtk_entry_icon_press (GtkEntry* _sender,
                                               GtkEntryIconPosition icon_pos,
                                               GdkEvent* event,
                                               gpointer self)
{
	_main_window___lambda7_ ((MainWindow*) self, icon_pos, event);
}

static void
_main_window___lambda8_ (MainWindow* self)
{
	main_window_on_entry_changed (self);
}

static void
__main_window___lambda8__gtk_editable_changed (GtkEditable* _sender,
                                               gpointer self)
{
	_main_window___lambda8_ ((MainWindow*) self);
}

static GObject *
main_window_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MainWindow * self;
	GtkLabel* fg_label = NULL;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* bg_label = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkStyleContext* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkEntry* _tmp9_;
	GtkEntry* _tmp10_;
	GSettings* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GtkEntry* _tmp14_;
	GtkEntry* _tmp15_;
	GtkEntry* _tmp16_;
	GtkEntry* _tmp17_;
	GSettings* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	GtkEntry* _tmp21_;
	GtkEntry* _tmp22_;
	GtkGrid* input_grid = NULL;
	GtkGrid* _tmp23_ = NULL;
	GtkGrid* _tmp24_;
	GtkLabel* _tmp25_;
	GtkGrid* _tmp26_;
	GtkEntry* _tmp27_;
	GtkGrid* _tmp28_;
	GtkLabel* _tmp29_;
	GtkGrid* _tmp30_;
	GtkEntry* _tmp31_;
	GtkLabel* _tmp32_;
	GtkLabel* _tmp33_;
	GtkLabel* _tmp34_;
	GtkStyleContext* _tmp35_;
	GtkLabel* _tmp36_;
	GtkLabel* _tmp37_;
	GtkLabel* _tmp38_;
	GradeLabel* _tmp39_;
	GradeLabel* _tmp40_;
	GradeLabel* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	GradeLabel* _tmp44_;
	GradeLabel* _tmp45_;
	GradeLabel* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	GradeLabel* _tmp49_;
	GradeLabel* _tmp50_;
	GradeLabel* _tmp51_;
	gchar* _tmp52_;
	gchar* _tmp53_;
	GtkGrid* results_grid = NULL;
	GtkGrid* _tmp54_;
	GtkGrid* _tmp55_;
	GtkGrid* _tmp56_;
	GtkStyleContext* _tmp57_;
	GtkGrid* _tmp58_;
	GtkLabel* _tmp59_;
	GtkGrid* _tmp60_;
	GradeLabel* _tmp61_;
	GtkGrid* _tmp62_;
	GradeLabel* _tmp63_;
	GtkGrid* _tmp64_;
	GradeLabel* _tmp65_;
	HdyHeaderBar* input_header = NULL;
	gchar* _tmp66_;
	HdyHeaderBar* _tmp67_ = NULL;
	GtkStyleContext* input_header_context = NULL;
	HdyHeaderBar* _tmp68_;
	GtkStyleContext* _tmp69_;
	GtkStyleContext* _tmp70_;
	GtkStyleContext* _tmp71_;
	GtkStyleContext* _tmp72_;
	GtkStyleContext* _tmp73_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp74_;
	GtkGrid* _tmp75_;
	HdyHeaderBar* _tmp76_;
	GtkGrid* _tmp77_;
	GtkGrid* _tmp78_;
	GtkGrid* _tmp79_;
	GtkGrid* _tmp80_;
	HdyWindowHandle* window_handle = NULL;
	HdyWindowHandle* _tmp81_;
	HdyWindowHandle* _tmp82_;
	GtkGrid* _tmp83_;
	HdyWindowHandle* _tmp84_;
	GtkEntry* _tmp85_;
	GtkEntry* _tmp86_;
	GtkEntry* _tmp87_;
	GtkEntry* _tmp88_;
	GtkEntry* _tmp89_;
	const gchar* _tmp90_;
	const gchar* _tmp91_;
	GtkEntry* _tmp92_;
	const gchar* _tmp93_;
	const gchar* _tmp94_;
	parent_class = G_OBJECT_CLASS (main_window_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
	hdy_init ();
	_tmp0_ = (GtkLabel*) gtk_label_new (_ ("Foreground Color"));
	g_object_ref_sink (_tmp0_);
	fg_label = _tmp0_;
	_tmp1_ = fg_label;
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _tmp1_);
	gtk_style_context_add_class (_tmp2_, "h4");
	_tmp3_ = fg_label;
	gtk_label_set_xalign (_tmp3_, (gfloat) 0);
	_tmp4_ = (GtkLabel*) gtk_label_new (_ ("Background Color"));
	g_object_ref_sink (_tmp4_);
	bg_label = _tmp4_;
	_tmp5_ = bg_label;
	_tmp6_ = gtk_widget_get_style_context ((GtkWidget*) _tmp5_);
	gtk_style_context_add_class (_tmp6_, "h4");
	_tmp7_ = bg_label;
	gtk_widget_set_margin_top ((GtkWidget*) _tmp7_, 12);
	_tmp8_ = bg_label;
	gtk_label_set_xalign (_tmp8_, (gfloat) 0);
	_tmp9_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->fg_entry);
	self->priv->fg_entry = _tmp9_;
	_tmp10_ = self->priv->fg_entry;
	_tmp11_ = harvey_settings;
	_tmp12_ = g_settings_get_string (_tmp11_, "fg-color");
	_tmp13_ = _tmp12_;
	gtk_entry_set_text (_tmp10_, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp14_ = self->priv->fg_entry;
	gtk_entry_set_placeholder_text (_tmp14_, "#333");
	_tmp15_ = self->priv->fg_entry;
	gtk_entry_set_icon_from_icon_name (_tmp15_, GTK_ENTRY_ICON_SECONDARY, "media-eq-symbolic");
	_tmp16_ = (GtkEntry*) gtk_entry_new ();
	g_object_ref_sink (_tmp16_);
	_g_object_unref0 (self->priv->bg_entry);
	self->priv->bg_entry = _tmp16_;
	_tmp17_ = self->priv->bg_entry;
	_tmp18_ = harvey_settings;
	_tmp19_ = g_settings_get_string (_tmp18_, "bg-color");
	_tmp20_ = _tmp19_;
	gtk_entry_set_text (_tmp17_, _tmp20_);
	_g_free0 (_tmp20_);
	_tmp21_ = self->priv->bg_entry;
	gtk_entry_set_placeholder_text (_tmp21_, "rgb (110, 200, 230)");
	_tmp22_ = self->priv->bg_entry;
	gtk_entry_set_icon_from_icon_name (_tmp22_, GTK_ENTRY_ICON_SECONDARY, "media-eq-symbolic");
	_tmp23_ = (GtkGrid*) gtk_grid_new ();
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp23_, GTK_ORIENTATION_VERTICAL);
	g_object_set ((GtkWidget*) _tmp23_, "margin", 12, NULL);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp23_, TRUE);
	g_object_ref_sink (_tmp23_);
	input_grid = _tmp23_;
	_tmp24_ = input_grid;
	_tmp25_ = fg_label;
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
	_tmp26_ = input_grid;
	_tmp27_ = self->priv->fg_entry;
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
	_tmp28_ = input_grid;
	_tmp29_ = bg_label;
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
	_tmp30_ = input_grid;
	_tmp31_ = self->priv->bg_entry;
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
	_tmp32_ = (GtkLabel*) gtk_label_new ("12:1");
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->results_label);
	self->priv->results_label = _tmp32_;
	_tmp33_ = self->priv->results_label;
	g_object_set ((GtkWidget*) _tmp33_, "expand", TRUE, NULL);
	_tmp34_ = self->priv->results_label;
	_tmp35_ = gtk_widget_get_style_context ((GtkWidget*) _tmp34_);
	gtk_style_context_add_class (_tmp35_, "h1");
	_tmp36_ = self->priv->results_label;
	gtk_label_set_selectable (_tmp36_, TRUE);
	_tmp37_ = self->priv->results_label;
	gtk_widget_set_valign ((GtkWidget*) _tmp37_, GTK_ALIGN_CENTER);
	_tmp38_ = self->priv->results_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp38_, GTK_ALIGN_CENTER);
	_tmp39_ = grade_label_new ("WCAG A");
	g_object_ref_sink (_tmp39_);
	_g_object_unref0 (self->priv->a_level);
	self->priv->a_level = _tmp39_;
	_tmp40_ = self->priv->a_level;
	gtk_widget_set_halign ((GtkWidget*) _tmp40_, GTK_ALIGN_CENTER);
	_tmp41_ = self->priv->a_level;
	_tmp42_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("3:1"), _ ("The minimum level recommended by ISO-9241-3 and ANSI-HFES-100-1988 for" \
" standard text and vision"));
	_tmp43_ = _tmp42_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp41_, _tmp43_);
	_g_free0 (_tmp43_);
	_tmp44_ = grade_label_new ("WCAG AA");
	g_object_ref_sink (_tmp44_);
	_g_object_unref0 (self->priv->aa_level);
	self->priv->aa_level = _tmp44_;
	_tmp45_ = self->priv->aa_level;
	gtk_widget_set_halign ((GtkWidget*) _tmp45_, GTK_ALIGN_CENTER);
	_tmp46_ = self->priv->aa_level;
	_tmp47_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("4.5:1"), _ ("Compensates for the loss in contrast that results from moderately low " \
"visual acuity, color deficiencies, or aging."));
	_tmp48_ = _tmp47_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp46_, _tmp48_);
	_g_free0 (_tmp48_);
	_tmp49_ = grade_label_new ("WCAG AAA");
	g_object_ref_sink (_tmp49_);
	_g_object_unref0 (self->priv->aaa_level);
	self->priv->aaa_level = _tmp49_;
	_tmp50_ = self->priv->aaa_level;
	gtk_widget_set_halign ((GtkWidget*) _tmp50_, GTK_ALIGN_CENTER);
	_tmp51_ = self->priv->aaa_level;
	_tmp52_ = g_strdup_printf ("<big><b>%s</b></big>\n%s", _ ("7:1"), _ ("Compensates for the loss in contrast sensitivity usually experienced b" \
"y users with about 20/80 vision. People with more than this degree of " \
"vision loss usually use assistive technologies."));
	_tmp53_ = _tmp52_;
	gtk_widget_set_tooltip_markup ((GtkWidget*) _tmp51_, _tmp53_);
	_g_free0 (_tmp53_);
	_tmp54_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp54_);
	results_grid = _tmp54_;
	_tmp55_ = results_grid;
	gtk_grid_set_row_spacing (_tmp55_, 12);
	_tmp56_ = results_grid;
	_tmp57_ = gtk_widget_get_style_context ((GtkWidget*) _tmp56_);
	gtk_style_context_add_class (_tmp57_, "results");
	_tmp58_ = results_grid;
	_tmp59_ = self->priv->results_label;
	gtk_grid_attach (_tmp58_, (GtkWidget*) _tmp59_, 0, 0, 3, 1);
	_tmp60_ = results_grid;
	_tmp61_ = self->priv->a_level;
	gtk_grid_attach (_tmp60_, (GtkWidget*) _tmp61_, 0, 1, 1, 1);
	_tmp62_ = results_grid;
	_tmp63_ = self->priv->aa_level;
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 1, 1, 1, 1);
	_tmp64_ = results_grid;
	_tmp65_ = self->priv->aaa_level;
	gtk_grid_attach (_tmp64_, (GtkWidget*) _tmp65_, 2, 1, 1, 1);
	_tmp66_ = g_strdup ("close:");
	_tmp67_ = (HdyHeaderBar*) hdy_header_bar_new ();
	hdy_header_bar_set_decoration_layout (_tmp67_, _tmp66_);
	_g_free0 (_tmp66_);
	hdy_header_bar_set_show_close_button (_tmp67_, TRUE);
	g_object_ref_sink (_tmp67_);
	input_header = _tmp67_;
	_tmp68_ = input_header;
	_tmp69_ = gtk_widget_get_style_context ((GtkWidget*) _tmp68_);
	_tmp70_ = _g_object_ref0 (_tmp69_);
	input_header_context = _tmp70_;
	_tmp71_ = input_header_context;
	gtk_style_context_add_class (_tmp71_, "input-header");
	_tmp72_ = input_header_context;
	gtk_style_context_add_class (_tmp72_, "default-decoration");
	_tmp73_ = input_header_context;
	gtk_style_context_add_class (_tmp73_, GTK_STYLE_CLASS_FLAT);
	_tmp74_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp74_);
	grid = _tmp74_;
	_tmp75_ = grid;
	_tmp76_ = input_header;
	gtk_grid_attach (_tmp75_, (GtkWidget*) _tmp76_, 0, 0, 1, 1);
	_tmp77_ = grid;
	_tmp78_ = input_grid;
	gtk_grid_attach (_tmp77_, (GtkWidget*) _tmp78_, 0, 1, 1, 1);
	_tmp79_ = grid;
	_tmp80_ = results_grid;
	gtk_grid_attach (_tmp79_, (GtkWidget*) _tmp80_, 1, 0, 1, 2);
	_tmp81_ = (HdyWindowHandle*) hdy_window_handle_new ();
	g_object_ref_sink (_tmp81_);
	window_handle = _tmp81_;
	_tmp82_ = window_handle;
	_tmp83_ = grid;
	gtk_container_add ((GtkContainer*) _tmp82_, (GtkWidget*) _tmp83_);
	_tmp84_ = window_handle;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp84_);
	_tmp85_ = self->priv->fg_entry;
	g_signal_connect_object (_tmp85_, "icon-press", (GCallback) __main_window___lambda5__gtk_entry_icon_press, self, 0);
	_tmp86_ = self->priv->fg_entry;
	g_signal_connect_object ((GtkEditable*) _tmp86_, "changed", (GCallback) __main_window___lambda6__gtk_editable_changed, self, 0);
	_tmp87_ = self->priv->bg_entry;
	g_signal_connect_object (_tmp87_, "icon-press", (GCallback) __main_window___lambda7__gtk_entry_icon_press, self, 0);
	_tmp88_ = self->priv->bg_entry;
	g_signal_connect_object ((GtkEditable*) _tmp88_, "changed", (GCallback) __main_window___lambda8__gtk_editable_changed, self, 0);
	_tmp89_ = self->priv->fg_entry;
	_tmp90_ = gtk_entry_get_text (_tmp89_);
	_tmp91_ = _tmp90_;
	_tmp92_ = self->priv->bg_entry;
	_tmp93_ = gtk_entry_get_text (_tmp92_);
	_tmp94_ = _tmp93_;
	main_window_style_results_pane (self, _tmp91_, _tmp94_);
	_g_object_unref0 (window_handle);
	_g_object_unref0 (grid);
	_g_object_unref0 (input_header_context);
	_g_object_unref0 (input_header);
	_g_object_unref0 (results_grid);
	_g_object_unref0 (input_grid);
	_g_object_unref0 (bg_label);
	_g_object_unref0 (fg_label);
	return obj;
}

static void
main_window_class_init (MainWindowClass * klass,
                        gpointer klass_data)
{
	main_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MainWindow_private_offset);
	((GtkWidgetClass *) klass)->configure_event = (gboolean (*) (GtkWidget*, GdkEventConfigure*)) main_window_real_configure_event;
	G_OBJECT_CLASS (klass)->constructor = main_window_constructor;
	G_OBJECT_CLASS (klass)->finalize = main_window_finalize;
}

static void
main_window_instance_init (MainWindow * self,
                           gpointer klass)
{
	self->priv = main_window_get_instance_private (self);
	self->priv->prev_foreground_entry = NULL;
	self->priv->prev_background_entry = NULL;
}

static void
main_window_finalize (GObject * obj)
{
	MainWindow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MAIN_WINDOW, MainWindow);
	_g_object_unref0 (self->priv->bg_entry);
	_g_object_unref0 (self->priv->fg_entry);
	_g_object_unref0 (self->priv->results_label);
	_g_object_unref0 (self->priv->a_level);
	_g_object_unref0 (self->priv->aa_level);
	_g_object_unref0 (self->priv->aaa_level);
	_g_free0 (self->priv->prev_foreground_entry);
	_g_free0 (self->priv->prev_background_entry);
	G_OBJECT_CLASS (main_window_parent_class)->finalize (obj);
}

static GType
main_window_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MainWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) main_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MainWindow), 0, (GInstanceInitFunc) main_window_instance_init, NULL };
	GType main_window_type_id;
	main_window_type_id = g_type_register_static (hdy_window_get_type (), "MainWindow", &g_define_type_info, 0);
	MainWindow_private_offset = g_type_add_instance_private (main_window_type_id, sizeof (MainWindowPrivate));
	return main_window_type_id;
}

GType
main_window_get_type (void)
{
	static volatile gsize main_window_type_id__once = 0;
	if (g_once_init_enter (&main_window_type_id__once)) {
		GType main_window_type_id;
		main_window_type_id = main_window_get_type_once ();
		g_once_init_leave (&main_window_type_id__once, main_window_type_id);
	}
	return main_window_type_id__once;
}

